SystemOrganization addCategory: #'Magma research-MagmaCollections'!

!MagmaCollection methodsFor: '*magma research' stamp: 'brp 4/6/2006 12:15'!
where: aBlock

	| reader |
	reader := MagmaExpressionReader new collection: self; yourself.
	aBlock value: reader.
	^ reader

		! !

MaObject subclass: #MaClause
	instanceVariableNames: 'reader index lowKey highKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma research-MagmaCollections'!

!MaClause methodsFor: 'operators' stamp: 'cmm 4/6/2006 20:45'!
between: lowObject and: highObject
	lowKey _ index indexHashForIndexObject: lowObject.
	highKey _ index indexHashForIndexObject: highObject! !

!MaClause methodsFor: 'operators' stamp: 'cmm 4/6/2006 20:44'!
equals: anObject
	lowKey _ highKey _ index indexHashForIndexObject: anObject! !

!MaClause methodsFor: 'accessing' stamp: 'brp 4/6/2006 12:10'!
highKey

	^ highKey
! !

!MaClause methodsFor: 'initialize-release' stamp: 'brp 4/6/2006 11:22'!
highKey: anInteger

	highKey := anInteger! !

!MaClause methodsFor: 'accessing' stamp: 'brp 4/6/2006 11:45'!
index

	^ index! !

!MaClause methodsFor: 'initialize-release' stamp: 'brp 4/6/2006 11:22'!
index: aMaIndexDefinition

	index := aMaIndexDefinition
! !

!MaClause methodsFor: 'accessing' stamp: 'brp 4/6/2006 12:09'!
lowKey

	^ lowKey
! !

!MaClause methodsFor: 'initialize-release' stamp: 'brp 4/6/2006 11:23'!
lowKey: anInteger

	lowKey := anInteger! !

!MaClause methodsFor: 'printing' stamp: 'brp 4/6/2006 11:44'!
printOn: aStream

	super printOn: aStream.
	aStream nextPut: $(; nextPutAll: self index attribute; nextPut: $)

! !

!MaClause methodsFor: 'accessing' stamp: 'brp 4/6/2006 12:09'!
reader

	^ reader
! !

!MaClause methodsFor: 'initialize-release' stamp: 'brp 4/6/2006 12:09'!
reader: aMagmaExpressionReader 

	reader := aMagmaExpressionReader ! !

!MaClause methodsFor: 'expressions' stamp: 'brp 4/6/2006 12:14'!
& aTerm
	"aTerm is a MaClause or a MaExpression"
	| expression |
	expression := MaExpression for: self and: aTerm.
	self reader expression: expression.
	^ expression ! !

!MaClause methodsFor: 'expressions' stamp: 'brp 4/6/2006 12:14'!
| aTerm
	"aTerm is a MaClause or a MaExpression"
	| expression |
	expression := MaExpression for: self or: aTerm.
	self reader expression: expression.
	^ expression ! !

MaObject subclass: #MaExpression
	instanceVariableNames: 'lhs operator rhs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma research-MagmaCollections'!

!MaExpression class methodsFor: 'as yet unclassified' stamp: 'brp 4/6/2006 11:42'!
for: lhs and: rhs

	^ self new
		lhs: lhs;
		operator: $&;
		rhs: rhs;
		yourself
! !

!MaExpression class methodsFor: 'as yet unclassified' stamp: 'brp 4/6/2006 11:41'!
for: lhs or: rhs

	^ self new
		lhs: lhs;
		operator: $|;
		rhs: rhs;
		yourself
! !

!MaExpression methodsFor: 'accessing' stamp: 'brp 4/6/2006 12:07'!
lhs

	^ lhs
! !

!MaExpression methodsFor: 'accessing' stamp: 'brp 4/6/2006 12:06'!
lhs: aTerm

	lhs := aTerm! !

!MaExpression methodsFor: 'accessing' stamp: 'brp 4/6/2006 12:07'!
operator

	^ operator
! !

!MaExpression methodsFor: 'accessing' stamp: 'brp 4/6/2006 12:06'!
operator: aCharacter

	operator := aCharacter
! !

!MaExpression methodsFor: 'printing' stamp: 'brp 4/6/2006 11:42'!
printOn: aStream

	super printOn: aStream.
	aStream nextPut: $(; nextPut: self operator; nextPut: $)

! !

!MaExpression methodsFor: 'accessing' stamp: 'brp 4/6/2006 12:07'!
rhs

	^ rhs
! !

!MaExpression methodsFor: 'accessing' stamp: 'brp 4/6/2006 12:06'!
rhs: aTerm

	rhs := aTerm! !

MaObject subclass: #MagmaExpressionReader
	instanceVariableNames: 'collection expression pageSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma research-MagmaCollections'!

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/6/2006 11:09'!
collection

	^ collection! !

!MagmaExpressionReader methodsFor: 'initialize-release' stamp: 'brp 4/6/2006 11:09'!
collection: aMagmaCollection

	collection := aMagmaCollection! !

!MagmaExpressionReader methodsFor: 'page' stamp: 'cmm 4/6/2006 20:47'!
doesNotUnderstand: aMessage
	^ MaClause new
		reader: self ;
		index: (collection indexNamed: aMessage selector) ;
		yourself! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/6/2006 12:12'!
expression

	^ expression! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/6/2006 12:12'!
expression: aTerm

	expression := aTerm
! !

!MagmaExpressionReader methodsFor: 'indexing' stamp: 'brp 4/6/2006 11:06'!
indexNamed: attributeSymbol

	^ self collection indexNamed: attributeSymbol
! !

!MagmaExpressionReader methodsFor: 'initialize-release' stamp: 'brp 4/6/2006 11:22'!
initialize

	super initialize.
	self pageSize: 125.
! !

!MagmaExpressionReader methodsFor: 'page' stamp: 'brp 4/6/2006 11:21'!
pageSize
	"The number of object retrieved to memory at a time."

	^ pageSize! !

!MagmaExpressionReader methodsFor: 'page' stamp: 'brp 4/6/2006 11:21'!
pageSize: anInteger 
	"Tell the receiver to retrieve anInteger number of elements at a time when 'scrolling' to a new part of the collection via at:."

	pageSize := anInteger! !

!MagmaExpressionReader methodsFor: 'private' stamp: 'brp 4/6/2006 12:12'!
readIndex: aMaIndexDefinition fromHash: lowHashValue toHash: highHashValue
	"Answers a MaLargeCollectionReader."

	| clause |
	clause := MaClause new
				reader: self;
				index: aMaIndexDefinition;
				lowKey: lowHashValue;
				highKey: highHashValue;
				yourself.

	self expression ifNil: [ self expression: clause ].
	^ clause
! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/6/2006 11:09'!
read: attributeSymbol
	"Answers a MaLargeCollectionReader with access to all of my elements."

	| index |
	index := self indexNamed: attributeSymbol.
	^ self
		readIndex: index
		fromHash: 0
		toHash: index highestPossibleKey! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/6/2006 11:10'!
read: attributeSymbol at: key
	"Answers a MaLargeCollectionReader with access to all elements at key."

	^ self
		read: attributeSymbol
		from: key
		to: key! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/6/2006 11:10'!
read: attributeSymbol from: lowKey
	"Answers a MaLargeCollectionReader with access to all of my elements after lowKey."

	| index |
	index := self indexNamed: attributeSymbol.
	^ self
		readIndex: index
		fromHash: (index indexHashForIndexObject: lowKey)
		toHash: index highestPossibleKey! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/6/2006 11:10'!
read: attributeSymbol from: startKey to: endKey
	"Answers a MaLargeCollectionReader with access to all of my elements between startKey and endKey."

	| index |
	index := self indexNamed: attributeSymbol.
	^ self
		readIndex: index
		fromHash: (index indexHashForIndexObject: startKey)
		toHash: (index indexHashForIndexObject: endKey)! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/6/2006 11:04'!
read: attributeSymbol from: startKey upTo: endKey
      "Answers a MaLargeCollectionReader with access to all of my elements between startKey and endKey, but NOT including endKey.  This is useful with MaByteSequenceIndexDefinitions where you want to find all matching the left-side of a particular key."

	| index |
	index := self indexNamed: attributeSymbol.
	^ self
		readIndex: index
		fromHash: (index indexHashForIndexObject: startKey)
		toHash: ((index indexHashForIndexObject: endKey) - 1 max: 0)! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/6/2006 11:10'!
read: attributeSymbol to: highKey
	"Answers a MaLargeCollectionReader with access to all of my elements up to highKey."

	| index |
	index := self indexNamed: attributeSymbol.
	^ self
		readIndex: index
		fromHash: 0
		toHash: (index indexHashForIndexObject: highKey)! !

!MagmaExpressionReader methodsFor: 'initialize-release' stamp: 'brp 4/6/2006 11:23'!
release

	super release.
	"self removeListener"! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/6/2006 11:04'!
size

	^ self error: 'to do'! !
